/*
 * Copyright (c) 2007 Gerhard Beck. All rights reserved.
 * 
 * Subject to the GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007
 * http://www.gnu.org/licenses/gpl.html
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GERHARD
 * BECK OR OTHER CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.gerhardb.jibs;

import org.gerhardb.lib.util.startup.AppPluginStartup;


/**
 * Sets up classpath and then calls JIBS.
 * Used for thumbdrives and checking for plugins.
 */
public class JibsJarStartup
{	
	// ==========================================================================
	// MAIN
	// ==========================================================================
	/**
	 * Sets up classpath and starts JIBS.
	 * 
	 * @param args
	 */
	public static void main(String[] args)
	{
		System.out.println("JIBS starting with main(): JibsJarStartup");
		
		// First "org.gerhardb.jibs.Jibs" is the main class.
		// Second "org.gerhardb.jibs.Jibs" is the localization root to use.
		// Generally they may be same, but may want to point to main file for lesser applications.
		// null for backwards compatibility
		AppPluginStartup.startupAppWithPlugins("org.gerhardb.jibs.Jibs", "jibs.props", args);
	}
}